/* 
 *  
 Это С У П детка!
     у м о
     п н д
     е а с
     р я в
     к   е
     р   т
     у   к
     т   а
     а
     я
  основные функции: + повышение яркости при срабатывании датчика движения;
                    + плавное снижение яркости при отсутствии движений в зоне видимости датиков;
                    + возможность переключения цветов с помощью сенсорной кнопки;
                    + отдельный режим изменяющий цвет в зависимости от температуры;
                    + настройка уровня яркости удержанием сенсорной кнопки;
                    + все настройки сохранятся в долговременную память.   
         LEDstrip        
         _____________________________________________________________________________________________________
   + ---|     _____      _____      _____      _____      _____      _____      _____      _____      _____   |
   G ---|    |     |    |     |    |     |    |     |    |     |    |     |    |     |    |     |    |     |  |
   R ---|    |_____|    |_____|    |_____|    |_____|    |_____|    |_____|    |_____|    |_____|    |_____|  |
   B ---|_____________________________________________________________________________________________________|
*/
#define outLedGreen 9           // пин управления зелёным цветом
#define outLedRed 10            // пин управления красным цветом
#define outLedBlue 11           // пин управления синим цветом
#define button 3                // пин к которому подключена кнопка
#define mooveSensor 2           // пик к которому подключён датчик движения
#define UP_SIDE_BRIGHTNES 100   // максимальная яркость в процентах
#define DOWN_SIDE_BRIGHTNES 2   // минимальная яркость в процентах 
#define DELAY_INT 10            // шаг регулировки яркости
#define LIGHT_OFF_TIME 50       // время перехода на другой режим яркости в секундах + 7  держит сам датчик

//--- МАССИВ ЦВЕТОВ-----
int LEDcolor[][3] = {
  {0, 0, 0},      // 0 чёрный
  {255,255, 255}, // 1 белый
  {255, 0, 0},    // 2 красный
  {255,65,0},     // 3 оранжевый
  {255, 255, 0},  // 4 жёлтый 
  {153,255,51},   // 5 салатовый
  {0, 255, 0},    // 6 зелёный
  {0, 255, 255},  // 7 аквамарин
  {0, 0, 255},    // 8 синий
  {80, 0, 80},    // 9 фиолетовый
  };  //
// ----БИБЛИОТЕКИ-------------
#include "GyverButton.h" // библиотека для работы с кнопкой 
GButton butt1(button);   // создаём объект - кнопку
#include <EEPROM.h>      // библиотека для работы с памятью

// ----ПЕРЕМЕННЫЕ--------------  
int b, color, ledBrightness1,ledBrightness2, buttonHoldValue1,buttonHoldValue2, masSize, currentBrightLevel;
unsigned long timeout;
bool holdFlag, moove;

void setup() {
//Serial.begin(9600);  

butt1.setType(LOW_PULL);
butt1.setTickMode(AUTO);
  pinMode(button, INPUT);
  pinMode(mooveSensor, INPUT);
  pinMode(outLedRed, OUTPUT);
  pinMode(outLedGreen, OUTPUT);
  pinMode(outLedBlue, OUTPUT);
masSize = sizeof( LEDcolor ) / sizeof( LEDcolor[ 0 ] ); // определяет размер массива цветов

// ---- считываем из EEPROM-----
color = EEPROM.read(0);                  // считываем цвет из памяти 
ledBrightness1 = EEPROM.read(1);          // считываем 1-ю яркость из памяти
ledBrightness2 = EEPROM.read(2);  // считываем 2-ю яркость из памяти
b = ledBrightness1;
}

void loop() 
{
butt1.tick();
mooveAndBrightness();  

// -------обрабработка удержания и повышения яркости--------------
if (butt1.isHold()&& !holdFlag) 
   {                              
    if (!moove) buttonHoldValue1++;
    if (moove)  buttonHoldValue2++;                                        
    buttonHoldValue1 = constrain(buttonHoldValue1, DOWN_SIDE_BRIGHTNES, UP_SIDE_BRIGHTNES); // ограничение границ яркости
    buttonHoldValue2 = constrain(buttonHoldValue2, DOWN_SIDE_BRIGHTNES, UP_SIDE_BRIGHTNES); // ограничение границ яркости
    ledBrightness1 = buttonHoldValue1;
    ledBrightness2 = buttonHoldValue2;     
       
   }
//------если кнопку отпустили--------------   
if (butt1.isRelease())
    {
      holdFlag=!holdFlag;
      EEPROM.write(1, ledBrightness1);
      EEPROM.write(2, ledBrightness2);      
    }
//------обрабработка удержания и снижения яркости--------------       
if (butt1.isHold()&&holdFlag )
   {
      if (!moove) buttonHoldValue1--; 
      if (moove)  buttonHoldValue2--;    
      buttonHoldValue1 = constrain(buttonHoldValue1, DOWN_SIDE_BRIGHTNES, UP_SIDE_BRIGHTNES); // ограничение границ яркости
      buttonHoldValue2 = constrain(buttonHoldValue2, DOWN_SIDE_BRIGHTNES, UP_SIDE_BRIGHTNES); // ограничение границ яркости
      ledBrightness1 = buttonHoldValue1;
      ledBrightness2 = buttonHoldValue2;
   }
   // ------ обработка кликов и переключения цветов-----
   if (butt1.isClick()) color++, EEPROM.write(0, color);
   if (color<masSize) sendToSrtip();
       else color=0;        // следующий клик начинаем сначала    

 
}
//------- обработка датчика движения и плавного изменения ркости 
void mooveAndBrightness() 
{ 
  if(digitalRead(mooveSensor)) currentBrightLevel = ledBrightness2, moove = true, timeout = millis(); // ??????????
 
  if (millis() - timeout > LIGHT_OFF_TIME*1000)
  {
    currentBrightLevel = ledBrightness1, moove = false;
  }  
 if(digitalRead(mooveSensor)) currentBrightLevel = ledBrightness2, moove = true;
 while (b!=currentBrightLevel)
        {
        if (b<currentBrightLevel) b++;
           else  b--;   
        sendToSrtip();
        delay(DELAY_INT);
        }
}

void sendToSrtip()
{
analogWrite(outLedRed, LEDcolor[color][0]*b/ 100); 
analogWrite(outLedGreen, LEDcolor[color][1]*b/ 100);
analogWrite(outLedBlue, LEDcolor[color][2]*b/ 100); 

Serial.print(" moove - ");
Serial.print(digitalRead(mooveSensor)); 
Serial.print(" currentBrightLevel - ");
Serial.print(currentBrightLevel); 
Serial.print(" b - ");
Serial.print(b); 
Serial.print("  ledBrightness1  ");
Serial.print(ledBrightness1);  
Serial.print("  ledBrightness2  ");
Serial.print(ledBrightness2); 
Serial.print("  time ");
Serial.println((millis() - timeout)/1000); 

    
}
